#ifndef ELEMENTUPDATE_H
#define ELEMENTUPDATE_H

#include "FixVec.h"
// #include "MemoryManager.h"

#include "VelocityExt.h"

using namespace AMDiS;

class ElementUpdate
{
 public:
  MEMORY_MANAGED(ElementUpdate);

  /**
   * Constructor.
   */
  ElementUpdate(VelocityExt *velExt_)
    : velExt(velExt_)
  {};

  /**
   * Virtual destructor.
   */
  virtual ~ElementUpdate() {};

  /**
   * Pure virtual function.
   * Calculate Bornemann update on an element. Realization is implemented for
   * dimensions 2 and 3.
   */
  virtual double calcElementUpdate(const FixVec<WorldVector<double> *, VERTEX> &vert,
				   FixVec<double, VERTEX> &uhVal) = 0;

 protected:
  /**
   * Object needed to extrapolate velocity from the interface.
   */  
  VelocityExt *velExt;
};

#endif // ELEMENTUPDATE_H
