#ifndef ELEMENTUPDATE_2D_H
#define ELEMENTUPDATE_2D_H

#include "FixVec.h"
// #include "MemoryManager.h"

#include "ElementUpdate.h"
#include "VelocityExt.h"

using namespace AMDiS;

class ElementUpdate_2d : public ElementUpdate
{
 public:
  MEMORY_MANAGED(ElementUpdate_2d);

  /**
   * Constructor.
   */
  ElementUpdate_2d(VelocityExt *velExt_ = NULL)
    : ElementUpdate(velExt_)
  {};

  /**
   * Realization of ElementUpdate::calcElementUpdate.
   * Calculates the Bornemann update for an element.
   */
  double calcElementUpdate(const FixVec<WorldVector<double> *, VERTEX> &vert,
			   FixVec<double, VERTEX> &uhVal);
};

#endif // ELEMENTUPDATE_2D_H

